  Question Frquemment Poses  propos de Debian GNU Hurd et de HurdFr

Ce document tente de rpondre aux questions les plus frquement poses
par les utilisateurs lorsqu'ils essayent d'installer, d'utiliser, 
ou de dvelopper Debian GNU Hurd.
Il rpond aussi  quelques questions sur le projet HurdFr.
Vous tes pris de lire attentivement ce qui suit avant de demander 
de l'aide.

Debian GNU Hurd est activement dveloppe, et une version stable n'a pas 
encore vu le jour. Soyez prvenu que : il y a beaucoup de travail
 finir ; vous trouverez des bugs ; votre systme crashera. Ceci dit, vous 
pouvez contribuer  de nombreux niveaux : dvelopper Hurd et Mach, 
porter des applications, crire de la documentation, et, le plus important, 
les reports des utilisateurs.

Si vous avez une question qui n'est pas cite dans ce document,
envoyez nous la (avec la rponse si possible!).

The copyright to each section is help by its respective author(s).
Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.1 or
any later version published by the Free Software Foundation; with no
Invariant Sections, with no Front-Cover Texts and with no Back-Cover
Texts.  A copy of the license is included in the file COPYING.

                                                     Neal H Walfield
						     neal@cs.uml.edu

Traduit en partie par Gibran Hasnaoui <gibran@hurdfr.org>


                           Table Of Contents
                           -----------------

                           1 Le projet HurdFr

1.1 	But

                             2 Gnralits

2.1 	Qu'est ce qu'un micro-noyau multi-serveurs?

2.2 	Grammaticalement, qu'est ce que Hurd?

2.3 	Quelles sont les listes de diffusion?

2.4 	O puis-je rapporter les bugs?

2.5 	Y a-t-il une liste TODO?

2.6 	Quand sort la prochaine version?

2.7 	Pourquoi `/usr' est-il un lien symbolique vers `.'?

                             3 Installation

3.1 	O puis-je obtenir Debian GNU Hurd?

3.2 	Comment puis-je installer Debian GNU Hurd?

3.3 	Quels type de matriel est support?

3.4 	Quel type de partition dois-je utiliser pour mes partitions GNU Hurd?

3.5 	Comment dois-je nommer les partitions?

3.6 	Puis-je utiliser des partitions de plus d'1 Go?

3.7 	De combien de swap ai-je besoin?

3.8 	Puis-je partager la swap entre Linux et Hurd?

3.9 	Pourquoi j'obtiens ``Operation not permitted error''?

3.10 	Lorsque `native-install' a fini, J'ai d taper ccoommee cceeccii.  
	En particulier, j'ai du taper rreebboott pour redmarrer.

                             4 Paramtrages

4.1 	Comment puis-je ajouter un partition de swap?

4.2 	Comment puis-je configurer le rseau?
	Comment puis-je configurer une interface de loopback?

4.3 	Comment passer des options  `serverboot'?

4.4 	Puis-je utiliser la version GNU/Linux de `e2fsck' pour une partition Hurd?

4.5 	Pourquoi les pipes ne marchent-ils pas?

                             5 Utilisation

5.1 	O est la documentation?

5.2 	Qu'est ce qu'un translator (traducteur)?

5.3 	Qu'est ce que le shell login?

5.4 	Comment puis-je utiliser un clavier non-US?

5.5 	Comment puis-je activer la couleur dans la console?

5.6 	Comment puis-je utiliser les consoles virtuelles?

5.7 	Quel est le statut de X?

5.8 	Pourquoi X ne marche-t-il pas?

5.9 	Quels sont ces tranges pids `2' and `3'?

5.10 	Pourquoi `ps aux' me donne des rsultats bizarres ?

5.11 	J'ai un processus bloquant que je veux tuer, cependant, `ps' se 
	bloque aussi.

5.12 	O sont ...

5.13 	Y a t il un systme de fichier proc?

5.14 	Pourquoi la commande `df' ne fonctionne pas?

5.15 	Pourquoi mes translators meurent-ils?

                              6 Problmes

6.1 	Lorsque l'APM du BIOS stoppe mes disques durs, Hurd n'arrive pas  
	les relancer, que se passe-t-il?

6.2 	Quels sont ces messages relatifs  `default pager', `paging',
	et `pager request'?

6.3 	Que signifie gratuitous error?

6.4 	Que signifie ``/dev/hd0s1: MOUNTED READ-ONLY; MUST USE `fsysopts
	--writable'''?

6.5 	Quand Hurd crashe, GNU Mach redemmare automatiquement. Y a-t-il
	un moyen de le mettre en pause pour que je puisse noter l'erreur?

                                7 Porter

7.1 	Quels programmes ont t ports?

7.2 	Est-ce facile de porter?

7.3 	Comment puis-je aider?

                               8 Compiler

8.1 	O puis-je obtenir les sources?

8.2 	Puis-je faire une compilation croise?

8.3 	Des astuces, conseils ?

                              9 Dvelopper

9.1 	Comment puis-je utiliser `read()' pour lire un repertoire?

9.2 	Qu'est ce qu'OSKit-Mach?

9.3 	O est la documentation?

9.4 	Comment savoir si mon code est compatible POSIX?

9.5 	O envoyer les patchs?



                           1 Le projet HurdFr

1.1 	But

{HurdFr} HurdFr est une communaut de personnes passiones par GNU Hurd, 
communaut dont le but principal pour le moment est de rassembler
des dveloppeurs afin de contribuer au Hurd en fournissant du code,
de la documentation, etc.
A long terme, HurdFr organisera, nous l'esprons, des runions, 
confrences et d'autres choses que fait un HUG (Hurd User Group).

Venez nous rejoindre et contribuer  ce qui deviendra incontestablement 
l'OS du XXIme sicle !

	http://www.hurdfr.org

                             2 Gnralits

2.1 	Qu'est ce qu'un micro-noyau multi-serveurs?

{NHW} Le terme de micro-noyau n'est pas en rfrence  la taille du noyau, 
mais plutt aux services qu'il fournit.
Il est gnralement dit qu'il s'agit d'une srie d'interfaces permettant aux 
processus de communiquer entre eux et une faon d'accder au matriel.
Les ``Pilotes Logiciels'', comme j'aime  les appeler, sont alors implments
dans l'espace utilisateur en temps que serveurs.
Les exemples les plus vidents sont la pile TCP/IP, les systmes de fichier 
ext2 et NFS.
Dans le cas du Hurd, les utilisateurs ont accs  des fonctionnalits
auxquelles ils ne peuvent pas avoir accs dans un noyau monolithique, et
ce du fait que les serveurs tournent dans l'espace utilisateur.
Par exemple, ds que l'utilisateur les a lancs, celui-ci peut monter
un systme de fichier ftp dans son rpertoire personnel.

Pour plus d'information sur la conception de Hurd, lisez ``Vers une 
nouvelle stratgie de conception des OS'' de Thomas Bushnell, BSG :

	http://www.gnu.org/software/hurd/hurd-paper.html (anglais)
	http://www.hurd-fr.org/strat.php (franais)

Pour savoir pourquoi la FSF dveloppe un nouveau noyau:

	http://www.gnu.org/software/hurd/hurd-and-linux.html

2.2 	Grammaticalement, qu'est ce que Hurd?

{NHW} Hurd signifie ``Hird of Unix Replacing Daemons.'' Et Hird, 
``Hurd of Interfaces Representing Depth.''

Quand on se rfre au noyau on dit ``Mach'', et on l'utilise en tant
que nom propre. Par exemple: ``Le noyau GNU Mach utilise les pilotes
de priphriques de la version 2.0.x du noyau Linux''.

Quand on parle des serveurs, on dit ``Le Hurd.'' Par exemple:
Le systme de fichier ext2 est fourni par le Hurd, non pas par Mach.
Note, il est faux de dire: ``HURD'', ``le HURD'' ou ``le hurd''.

``GNU Hurd'' est utilis lorsque l'on veut parler du systme 
d'exploitation, e.g. ``Actuellement, Debian est la seule distribution 
de GNU Hurd.''

Finalement, il y a ``Debian GNU Hurd''. Cela se rfre  la distribution
cre par les dveloppeurs Debian. Par exemple: ``Ton portable tourne 
sous quoi?  Debian GNU Hurd, bien sur.''

2.3 	Quelles sont les listes de diffusion?

{NHW} Il y a quatres listes de diffusion principales:

- bug-hurd@gnu.org:  dveloppement de Hurd et Mach.

- help-hurd@gnu.org: questions gnrales sur Hurd.

- web-hurd@gnu.org:  maintenance des pages web de http://hurd.gnu.org.

- debian-hurd@lists.debian.org: tout ce qui est relatif  Debian GNU Hurd
  (en particulier le portage d'applications).

Inscrivez-vous de la manire habituelle.
( http://mail.gnu.org/mailman/listinfo et 
http://www.debian.org/MailingLists/subscribe )

2.4 	O puis-je rapporter les bugs?

{NHW} Utilisez le systme de gestion de bug de Debian. 
Voir http://www.debian.org/Bugs pour en savoir plus sur le BTS 
(Bug Tracking System).

2.5 	Y a-t-il une liste TODO?

{NHW} Oui, il y'en a, en fait, plusieurs.

- http://www.debian.org/ports/hurd/hurd-devel-tasks

- <hurd>/tasks

- <hurd>/TODO

2.6 	Quand sort la prochaine version?

{NHW} Personne ne semble le savoir. Cependant, le Hurd est utilisable, 
essayez-le et aidez nous  le finaliser.

2.7 	Pourquoi `/usr' est-il un lien symbolique vers `.'?

{MB} La distinction entre / et /usr a une justification historique, du temps o
les systmes Unix taient amorcs  partir de deux bandes, une
petite bande root et une plus grosse bande usr. Ajourd'hui, il est toujours
pratique d'avoir des partitions spares pour ces deux espaces. Hurd se
dbarasse de ces rebuts historiques, parce que nous pensons avoir trouv une
solution plus souple, les systmes de fichiers cachs. Malheureusement
shadowfs n'est pas encore implment.

                             3 Installation

3.1 	O puis-je obtenir Debian GNU Hurd?

{NHW} Comme GNU Hurd est un portage officiel instable de Debian, vous 
pouvez trouver les binaires sur votre miroir local. Il y a cependant 
de nombreux paquets qui ne compilent pas proprement  partir des sources 
et qui ont donc subi de nombreuses modifications (NDT: l'auteur dit "hack", on peut donc conclure qu'il s'agit plutt de "bidouilles" :-). 
Ils peuvent tre trouvs  l'adresse:

	ftp://alpha.gnu.org/pub/hurd/debian

Un fois que vous avez install correctement Debian GNU Hurd, vous 
pouvez configurer apt en ajoutant ceci  votre /etc/apt/sources.list, 
pour qu'il rcupre correctement les packages :

	deb ftp://alpha.gnu.org/pub/gnu/hurd/debian unstable main
	deb http://http.us.debian.org/debian unstable main

Le tlchargement des packages peut tre long (il y a plus d'un Go de
fichier), Philip Charles a cre des CDs Debian GNU Hurd.
Les revendeurs peuvent tre trouvs ici:

	http://www.debian.org/ports/hurd/hurd-cd

3.2 	Comment puis-je installer Debian GNU Hurd?

{NHW} Consultez un des nombreux guides. Le plus  jour peut tre trouv 
 cette adresse:

	http://web.walfield.org/papers/hurd-installation-guide/

3.3 	Quels type de matriel est support?

{NHW} Actuellement, GNU Hurd tourne seulement sur les machines de type 
IA32. Cependant, le porter sur d'autre architectures ne devrait pas tre 
difficile: le code a toujours t crit dans un souci de portabilit.

Par respect, GNU Mach utilise un sous-ensemble de pilotes du noyau 
Linux 2.0.x. Un guide relativement complet du matriel support
peut tre trouv  l'adresse:

	http://www.urbanophile.com/arenn/hacking/hurd/hurd-hardware.html

Si vous avez des problmes, c'est gnralement car:

- Vous utilisez le partage d'IRQ; GNU Mach ne supporte pas cela.

- Un pilote de priphrique monopolise le materiel et active accidentellement
  le mauvais priphrique.

Dans le premier cas, vous devrez enlever le priphrique ou jouer avec la 
configuration du BIOS.
Dans le second, vous devrez recompiler un nouveau noyau avec uniquement
les pilotes dont vous aurez besoin (GNU Mach ne supporte pas les modules
chargeables).

3.4 	Quel type de partition dois-je utiliser pour mes partitions GNU Hurd?

{MB} Choisissez un systme de fichier ext2. L'autre solution est
d'utiliser ufs, dans le style BSD. Le numro de type de partition
pour ext2fs est 0x83 (le mme que pour Linux), et pas 0x63 (GNU Hurd).
Thomas explique pourquoi 0x63 n'est pas le bon choix:

	Un jour, nous crerons peut-tre un nouveau format de systme de
	fichier, qui s'appellera probablement le systme de
	fichier GNU Hurd, et pourrait bien utiliser ce code de partition.

Mais de toute faon, il est toujours erron d'utiliser ce
code pour une partition ext2fs, comme le fait remarquer Roland.

3.5 	Comment dois-je nommer les partitions?

{MB,NHW} Je savais que vous poseriez cette question. Si je devais rduire
cette FAQ  une seule question, je choisirai celle-ci. C'est
plutt simple, mais vous devez savoir qu'il y a en ralit trois conventions
de nommage.

Premirement, le Hurd : si le disque en question est SCSI, vous devez 
savoir le numro de priphrique SCSI; si c'est un disque IDE, vous devez
savoir sur quel contrleur il est, et s'il est matre ou esclave.

Le Hurd utilise la convention de nommage BSD, qui dit que les disques 
sont rangs selon leur emplacement, numriquement, en commencant par
zro.
Ce schma est proche de celui trouv dans Linux, o le disque matre
du contrleur primaire est dsign par `hda' et l'esclave par `hdb'.
Sur le second contrleur, le matre et l'esclave sont dsigns
respectivement par `hdc' et `hdd'.
Sous Hurd, `hda' devient `hd0', `hdb' sera `hd1', etc.

Dans le Hurd, comme dans BSD, les partitions sont appeles `slices', 
et sont numrotes en commenant par un. Donc, pour nommer une 
partition particulire, on prend le nom du disque, on ajoute un `s' et 
le numro de la partition. Encore une fois, c'est similaire  Linux, 
sauf qu'il n'y a pas de `s'. Par exemple, `hda1' devient `hd0s1'.

GRUB, le chargeur de dmarrage, utilise une nomenclature compltement
diffrente: il interroge le BIOS et attache chaque disque  un 
tableau.
Les disques et partitions sont numrs en partant de zro.
Le format est : `hd (<disque>, <partition>)'. Donc, `hd(0, 1)' reprsente
la seconde partition du premier lecteur dtect par le BIOS.
Maintenant, grce  la compltion automatique de GRUB, il n'y a 
pas de problme.

3.6 	Puis-je utiliser des partitions de plus d'1 Go?

{NHW} Non, pas avant que libdiskfs soit rcrite et LFS implment.
Des efforts sont faits  en ce moment, cependant, ce n'est pas une
priorit pour les dveloppeurs.

3.7 	De combien de swap ai-je besoin?

{NHW} Gnralement, beaucoup ; ds qu'elle s'puise, Mach panique. 
J'ai au moins 128Mo de ram et 256Mo de swap sur toutes mes machines Hurd.

3.8 	Puis-je partager la swap entre Linux et Hurd?

{NHW} Oui. Le pager par defaut reconnait et respecte les partitions de 
swap Linux. Il paginera sur une partition vierge, c'est  dire, tout ce 
qu'il ne reconnaitra pas en temps que swap Linux. Alors : SOYEZ PRUDENT.

3.9 	Pourquoi j'obtiens ``Operation not permitted error''?

{MB} Vous avez oubli d'indiquer que le propritaire du systme de 
fichiers de la partition Hurd est hurd. Hurd utilise des
informations supplmentaires dans les inodes pour positionner les
traducteurs.
Pour que a fonctionne, il faut que la partition soit marque comme
``appartenant  Hurd''. Ceci se fait en passant l'option `-o hurd'
 `mke2fs' lorsque l'on cre une partition ext2  partir d'un autre
systme (les systmes de fichiers crs sous Hurd ont cette option 
par dfaut).
Vous pouvez toujours utiliser le script `e2os' si vous chouez.

3.10 	Lorsque `native-install' a fini, J'ai d taper ccoommee cceeccii.  
	En particulier, j'ai du taper rreebboott pour redmarrer.

{MB} Marrant, non ? En plus du serveur `term' de secours dans 
`/tmp/console', un autre serveur `term' a dmarr et sme la pagaille au
niveau de la sortie du clavier. Aprs un ramorage ce problme disparait
et un seul serveur `term' subsistera. Si `tar' supportait les translators, 
nous n'aurions pas ce problme.
Mme si vous ne rencontrez pas ce problme juste aprs l'installation, 
redmarrez immdiatement pour ne pas avoir affaire  ce bug par accident.

                             4 Paramtrages

4.1 	Comment puis-je ajouter un partition de swap?

{MB} Une partition de swap est aussi appele un fichier de pagination. 
Habituellement, il est suffisant d'ajouter la partition de swap  
`/etc/fstab', comme vous le feriez sous Linux. Vous pouvez paginer 
sur une partition de swap Linux et Hurd respectera la signature 
de la swap Linux (pour les deux versions de Hurd).
Mais Hurd sera ravi de paginer sur tout autre espace disque et 
crasera tout ce qu'il y trouvera, donc faites attention !

Si vous prfrez paginer sur un fichier, ou tre certain qu'il vrifie la
signature de pagination Linux avant d'craser les donnes qui s'y
trouvent, vous devez modifier `/boot/servers.boot'. La syntaxe est le nom de
fichier spcial de la partition, suivi ventuellement du nom
du fichier de pagination sur un ext2fs, suivi d'un espace et au choix
`$(add-raw-paging-file)', `$(add-linux-paging-file)', ou
`$(add-paging-file)'. Le premier fonctionne avec n'importe quel fichier ou
partition, et ne respecte aucune signature. Le deuxime fait
une vrification de scurit, et ne fonctionne que si une signature de
pagination linux est trouve. Le troisime recherche une signature
de pagination (et la respecte le cas chant), mais passe en pagination
brute s'il n'en trouve pas. C'est le fonctionnement par dfaut des entres
de `/etc/fstab'.

4.2 	Comment puis-je configurer le rseau?
	Comment puis-je configurer une interface de loopback?

{MB} Dans le premier cas, soyez sr que GNU Mach a dtect votre
carte rseau.

D'une manire ou d'une autre, vous devez configurer `pfinet'. 
Voir:

	http://www.debian.org/ports/hurd/hurd-doc-server

N'oubliez pas d'diter `/etc/resolv.conf', `/etc/hosts', etc.

Evidemment, vous devez faire cela si la procdure d'installation ne l'a
pas fait pour vous.

4.3 	Comment passer des options  `serverboot'?

{MB} Il suffit de les passer au noyau (i.e.  l'invite de GRUB) et 
il les fera suivre  `serverboot' automatiquement.

4.4 	Puis-je utiliser la version GNU/Linux de `e2fsck' pour une partition Hurd?

{MB} Oui,  partir de la version `e2fsprogs-1.05'. Verifiez d'abord avec 
`e2fsck -V'.

{NHW} N'essayer pas de dfragmenter votre partition car cet utilitaire
ne connait pas les translators.

4.5 	Pourquoi les pipes ne marchent-ils pas?

{MB} `settrans -fgc /servers/socket/1 /hurd/pflocal' devrait amliorer 
les choses.

                             5 Utilisation

5.1 	O est la documentation?

{NHW} Il y a des pages de man et des fichiers info pour les commandes
et les translators Hurd.

La documentation est dans les binaires et peut tre trouve en passant
l'option `--help'  une commande donne. Par exemple:

	# /hurd/ext2fs --help

vous dira quels types d'option le translator ext2fs accepte.

5.2 	Qu'est ce qu'un translator (traducteur)?

{MB} Il y a un texte sur les translators disponible ici:

	http://www.debian.org/ports/hurd/hurd-doc-translator

Lisez-le et poser vos questions sur les listes de diffusion.

5.3 	Qu'est ce que le shell login?

{MB} Sous le Hurd, il existe une notion d'utilisateur non-log.
Cet utilisateur a des ids utilisateurs et des ids de groupes. 
Ceci du fait qu'Hurd  supporte des srie d'uid et de gid, et
une possibilit est la srie  vide. Au lieu de refuser l'accs,
le systmes de fichier de Hurd offre quatre triplets de permission
(i.e. rwx) servant  dterminer les privilges des utilisateurs sans
identits. Ceci doit cependant tre activ fichier par fichier. Par dfaut,
les autres triplets de permission sont utiliss.

Le shell login de Hurd est un shell fonctionnant avec des uids et des 
gids. Pour restreindre l'accs  vos fichiers, activez et changez les
quatres triplets de permission ou changez, dans /etc/passwd, le shell
de login de l'utilisateur `login' en `/bin/loginpr', qui implmente 
l'invite login standart.

5.4 	Comment puis-je utiliser un clavier non-US?

{NHW} En jetant un oeil :

	ftp://alpha.gnu.org/gnu/hurd/contrib/marcus/keymap.tar.gz

5.5 	Comment puis-je activer la couleur dans la console?

{NHW} Si vous utilisez le GNU Mach de Debian, vous pouvez changer 
votre terminal en `mach-color'. Par exemple:

	# export TERM=mach-color

5.6 	Comment puis-je utiliser les consoles virtuelles?

{NHW} Il n'y a actuelement aucun support pour les consoles virtuelles,
vous pouvez cependant utiliser `screen'. Dans tous les cas, c'est 
beaucoup plus flexible.

Kalle Olavi Niemitalo <tosi@ees2.oulu.fi> a commenc  travailer sur
colortext.
Son but tait de fournir un programme qui multiplie les consoles dans 
l'espace utilisateur en utilisant /deb/kbd. Voire:

	http://stekt.oulu.fi/~tosi/

{MB} Voici quelques options utiles  ajouter  votre ~/.screenrc 
permettant d'muler les terminaux virtuels de Linux un peu mieux.

	bindkey ^[O0 select 0
	bindkey ^[O1 select 1
	bindkey ^[O2 select 2
	bindkey ^[O3 select 3
	bindkey ^[O4 select 4
	bindkey ^[O5 select 5
	bindkey ^[O6 select 6
	bindkey ^[O7 select 7
	bindkey ^[O8 select 8
	bindkey ^[O9 select 9

	# Unfortunately, Mach ignores modifiers on Cursor keys.  This can be
	# fixed, however, for now, we shall just use other keys to move back, 
	# and forth.
	# ^[, is ALT and ","
	# ^[. is ALT and "."
	bindkey ^[, prev
	bindkey ^[. next

5.7 	Quel est le statut de X?

{MB} Ca marche! Les packages sont disponibles dans n'importe quel
miroir ftp de Debian. XFree86 4.0.2 est disponible, ainsi que quelques
serveurs v3. Les instructions sur "comment utiliser les packages"
sont dans les archives de la liste de diffusion :

	http://lists.debian.org/debian-hurd-0007/msg00013.html

5.8 	Pourquoi X ne marche-t-il pas?

{MB} Essayez `export LD_LIBRARY_PATH=/usr/X11R6/lib'. C'est un problme 
de rsolution des liens. Le systme Hurd veut utiliser `RPATH', cependant, 
Debian veut viter cela.

5.9 	Quels sont ces tranges pids `2' and `3'?

{MB} Deux est le noyau, trois est le pagineur par dfaut et quatre est
le systme de fichier root.

5.10 	Pourquoi `ps aux' me donne des rsultats bizarres ?

{MB} Essayez `ps Aux'.

5.11 	J'ai un processus bloquant que je veux tuer, cependant, `ps' se 
	bloque aussi.

{MB} Interompez-le et passer lui l'option `-M'.

{NHW} Par dfaut, `ps' rassemble les informations en provenance du
serveur proc et des processus en question (via leurs ports de message).
Si un processus se bloque, il ne sera pas capable de rpondre  son 
port de message et donc, ps attendra indfiniment. L'option `-M'
dit  ps de ne pas utiliser les ports de message.

5.12 	O sont ...

{MB} `fdisk' et `dmesg' ne sont pas encore ports.

A la place de `free', utilisez `vmstat' et `vminfo'.

{NHW} `ifconfig' n'existe pas. Essayer:

	# /hurd/pfinet --help

Pour dhcp, jetez un oeil  hurd/trans/pump.c; c'est le dbut d'un 
client dhcp pour Hurd. 

5.13 	Y a t il un systme de fichier proc?

{MB} Non. Peut-tre qu'il y aura une mulation un jour pour les 
programmes qui en ont besoin. Pour ce qui est du /proc vide, 
c'est juste un relicat d'un paquet Debian GNU/Linux (base-files).

Vous pouvez tester les priphriques existant avec l'utilitaire devprobe.

5.14 	Pourquoi la commande `df' ne fonctionne pas?

{NHW} Elle fonctionne, vous avez seulement  lui passer le systme
de fichier. E.g;

	# df /

5.15 	Pourquoi mes translators meurent-ils?

{NHW} Essayez de passer le drapeaux `-ap'  settrans. Par dfaut, 
settrans utilise un translator passif, par consquent, il n'y aura
pas de sortie sur votre terminal. En utilisant `-ap', vous 
positionerez  la fois un translator actif et passif, ce qui veut dire
que le translator dmarera immdiatement et son stderr sera connect
 votre terminal.

De plus, le plus gros problme est de passer des chemins relatifs  des
transtors passifs. Vous ne pouvez pas prdire quel sera le rpertoire
de travail d'un translator lorsqu'il est position en temps que 
translator passif.

                              6 Problmes

6.1 	Lorsque l'APM du BIOS stoppe mes disques durs, Hurd n'arrive pas  
	les relancer, que se passe-t-il?

{MB} L'APM n'est pas support dans la version actuelle de GNU Mach, dsol. 
Dsactivez l'APM dans la configuration de votre BIOS.

6.2 	Quels sont ces messages relatifs  `default pager', `paging',
	et `pager request'?

{MB} Le gestionnaire de pagination (default pager) gre l'allocation 
de mmoire virtuelle. S'il ne peut pas allouer une nouvelle page par 
manque de mmoire, des choses terribles peuvent arriver. Lorsque vous 
obtenez ce type d'erreur, soit vous avez besoin de plus de mmoire, 
soit vous avez dcouvert une fuite de mmoire. Ajoutez une partition 
de pagination.

6.3 	Que signifie gratuitous error?

{MB} Cela vient de strerror(EGRATUITOUS). D'aprs la documentation de
la glibc, c'est un code d'erreur qui ne sert pas :). Ce n'est pas tout  
fait vrai. En fait, cette erreur peut arriver losqu'une anomalie grave 
s'est produite. Les explications de Thomas:

     Plus pcisment, EGRATUITOUS signifie officellement qu'un serveur
     a rpondu d'un faon impossible, ou qui ne respectait pas le
     protocole. Il y a des cas dans Hurd o EGRATUITOUS est retourn
     alors qu'un autre code serait plus appropri.

Si vous pouvez reproduire ce message, faites un rapport de bug. Mais ne
faites pas de rapport de bug  propos de l'accs  /dev/fd, nous connaissons
ce cas.

6.4 	Que signifie ``/dev/hd0s1: MOUNTED READ-ONLY; MUST USE `fsysopts
	--writable'''?

{NHW} Dans ce cas, cela veut dire que /dev/hd0s1 n'a pas t dmont
proprement. Au dmmarage, Hurd lance ``fsck -p'' sur toutes partitions
qu'il trouve dans /etc/fstab, donc, vous devriez ajouter la partition 
 ce fichier. Si vous pensez que la partition est propre, vous pouvez
utiliser:

	# fsysopts /home --writable

qui demandera au translator position sur /home de passer de lecture-seul
 lecture/criture. Il est  noter que la commande sera envoye au systme
de fichier et non pas  store (e.g. /dev/hd0s1).

6.5 	Quand Hurd crashe, GNU Mach redemmare automatiquement. Y a-t-il
	un moyen de le mettre en pause pour que je puisse noter l'erreur?

{MB} Donnez l'option `-H'  init (ajoutez-la sur la ligne de commande
d'amorage), et `init' demandera  Mach d'entrer en dboguage noyau au lieu de
se ramorcer. A l'invite du dbogueur (`db>'), vous pouvez taper `reboot' pour
ramocer le systme.

                                7 Porter

7.1 	Quels programmes ont t ports?

{NHW} Plein, jetez un oeil aux archives Debian. Cependant, beaucoup de 
programmes ne ncessitent pas d'tre ports; ils n'ont simplement pas ts 
compils.

7.2 	Est-ce facile de porter?

{NHW} Porter des applications vers Hurd est relativement facile du 
moment que l'application est compatible POSIX, car le Hurd fait de 
son mieux pour tre un systme d'exploitation conforme.

L'erreur la plus rpandue est d'assumer que MAXPATHLEN et PATH_MAX sont 
dfinis. Sur la plupart des systmes d'exploitation, elles sont 
positiones  quelques milliers, cependant, sous Hurd, il n'y a pas de 
maximum, donc elles ne sont pas dfinies.
La meilleure chose  faire est de soumettre un patch qui alloue la mmoire 
dynamiquement  l'auteur original. (NDT: Il est dconseill de patcher
les sources pendant votre portage sans le signaler  l'auteur, car cel
risquerait de poser des problmes plus tard, si vous n'assurez plus le
maintien de la version Hurd...)

7.3 	Comment puis-je aider?

{NHW} Un travail consquent est fait par Jeff Bailey pour compiler tous
les paquets Debian. Jetez un oeil :

	http://people.debian.org/~jbailey/oasis/group/Debian/index.html

pour voir ce qui a dj t fait et comment aider.

                               8 Compiler

8.1 	O puis-je obtenir les sources?

{NHW} Les sources sont accessibles par CVS  l'adresse:

	:pserver:anoncvs@subversions.gnu.org:/cvs

Pour des accs anonymes, utiliser l'utilisateur `anoncvs' sans mot de 
passe.
Il y a trois modules important: `hurd', `mach' et `mig'.

Une interface web est aussi disponible : http://subversions.gnu.org.

Pour obtenir les sources des derniers paquets debian, jetez un oeil
 n'importe quel miroir debian.

8.2 	Puis-je faire une compilation croise?

{NHW} Oui. Si vous utilisez Debian GNU/Linux sur IA32, c'est plutt
facile, un compilateur crois ncessitant peu d'espace disque est 
disponible; tout ce que vous avez  faire est d'installer les paquets
gcc-i386-gnu et mig-i386-gnu.
Lorsque vous lancer configure, vous devrez spcifier les programmes 
directement:

	# MIG=/usr/bin/i386-gnu-mig CC=/usr/bin/i386-gnu-gcc \
	  ../src/hurd/configure ...

Si vous utilisez une autre distribution, vous devrez utiliser une 
mthode plus longue. Vous pouvez trouver des informations dans le
Cross Compiling HOWTO disponible :

	http://hurddocs.sourceforge.net/howto/cross.html (anglais)
	http://www.hurd-fr.org/cross-fr.php (franais)

Farid Hajji <farid.hajji@ob.kamp.net> parle de son experience 
(compilation croise sous FreeBSD) :

	http://lists.debian.org/debian-hurd-0012/msg00062.html

8.3 	Des astuces, conseils ?

{NHW} Oui, construire dans l'arborescence des sources n'a pas encore
t test. Essayez:

	# ../src/hurd/configure ...

                              9 Dvelopper

9.1 	Comment puis-je utiliser `read()' pour lire un repertoire?

{MB} Il est important de comprendre qu'il n'y a rien de spcial 
concernant un rpertoire sous Hurd, c'est simplement un fichier.
Cela va aussi avec le concept des translators, o un translator
peut grer autant un fichier qu'un rpertoire.

9.2 	Qu'est ce qu'OSKit-Mach?

{NHW} Il y a deux versions de Mach: GNU Mach et OSKit-Mach. 
La premire utilise les drivers de Linux 2.0.x alors que la seconde
utilise OSKit, provenant de l'universit d'Utah.
Si tout va bien, OSKit-Mach sera stabilis et deviendra le noyau 
officiel. Vous pouvez trouvez plus d'information sur OSKit :

	http://www.cs.utah.edu/flux/oskit

9.3 	O est la documentation?

{NHW} Il y a eu plusieurs livres crit sur le noyau Mach.
Les informations contenues sont encore pertinentes et doivent tre
considres comme lectures obligatoires pour les hackers potentiels:

	http://www.cs.cmu.edu/afs/cs/project/mach/public/www/doc/publications.html

La documentation concernant le Hurd est insuffisante. Le commencement 
d'un livre, ``The GNU Hurd'' est dans le rpertoire doc des sources de Hurd.
Vous pouvez le lire en utilisant:

	# info hurd

L'endroit le plus important est, bien sur, le code source; ceci ne veut
pas dire que nous n'apprecierons pas plus de documentation.
Pour commencer, regardez <hurd>/doc/navigating.

9.4 	Comment savoir si mon code est compatible POSIX?

{NHW} Malheuresement, vous devez acheter les standards POSIX auprs 
de l'IEEE. `The Single Unix Specification' version 2, est disponible 
gratuitement sur Internet.  Essayer:

	http://www.unix-systems.org/online.html

9.5 	O envoyer les patchs?

{NHW} S'il sont en raport avec Hurd, Mach, ou MiG, envoyez un patch au 
format unidiff  la liste de diffusion bug-hurd. Par exemple:

	# diff -urN hurd-orig hurd

S'ils sont en raport avec d'autre packages, le BTS de Debian est un bon
endroit. Dans ce cas, soyez sur d'avoir avertit du bug la liste de 
diffusion debian-hurd.

Les rponses ont t donnes par:

* {NHW} Neal H Walfield  <neal@cs.uml.edu>

* {MB} Marcus Brinkmann  <Marcus.Brinkmann@ruhr-uni-bochum.de>
